Subject: Re: [topgit] tg update error

From: Junio C Hamano <[email-masked]>
Date: Fri, 13 Feb 2009 18:02:56 -0800

Jeff King <[email-masked]> writes:

> On Thu, Feb 12, 2009 at 01:01:42PM -0800, Junio C Hamano wrote:
>
>> > Junio, I think we should probably revert b229d18 (and loosen
>> > symbolic-ref's check to just "refs/"). Even if you want to argue that
>> > topgit should be changed to handle this differently, we are still
>> > breaking existing topgit installations, and who knows what other scripts
>> > which might have relied on doing something like this.
>> 
>> I'm Ok with the revert (and I agree it is absolutely the right thing to do
>> at least for the short term).
>
> It looks like you have already pushed out the revert. But I think we
> need this on top to make topgit work correctly.

>
> -- >8 --
> Subject: [PATCH] symbolic-ref: allow refs/<whatever> in HEAD
>
> Commit afe5d3d5 introduced a safety valve to symbolic-ref to
> disallow installing an invalid HEAD. It was accompanied by
> b229d18a, which changed validate_headref to require that
> HEAD contain a pointer to refs/heads/ instead of just refs/.
> Therefore, the safety valve also checked for refs/heads/.
>
> As it turns out, topgit is using refs/top-bases/ in HEAD,
> leading us to re-loosen (at least temporarily) the
> validate_headref check made in b229d18a. This patch does the
> corresponding loosening for the symbolic-ref safety valve,
> so that the two are in agreement once more.
>
> Signed-off-by: Jeff King <[email-masked]>

Actually we should simply revert afe5d3d5 altogether with the above
message, as it introduced a test that expects the tightened behaviour.